%define		vboxdir		%{_libdir}/%{name}
%define		vbox_platform	linux.x86
%{!?kversion: %define kversion 2.6.26-9}

%define kmodver %(echo %{kversion} | tr - _)
%define relnr	1

# nuke vbox-specific dependencies
%define _provides_exceptions ^VBox
%define _requires_exceptions ^VBox

%define kvariants "" PAE

Distribution: 	CCux
Packager: 	Karsten Brockmann <arcam@ccux-linux.de>
Name: 		virtualbox
Summary:        A general-purpose full virtualizer for x86 hardware
Version: 	2.0.0
Release: 	1
License: 	GNU/GPL 
Group: 		Emulators
URL: 		http://www.virtualbox.org/
Source0: 	VirtualBox-%{version}-OSE.tar.bz2
Source1:	%{name}.run
Source2:	52-virtualbox.rules
Source3:	http://virtualbox.org/download/%{version}/VBoxGuestAdditions_%{version}.iso
Source10:	virtualbox.png
Source11:	virtualbox.16.png
Source12:	virtualbox.48.png
Source13:	virtualbox.desktop
# don't compile vbox with debug flags
Patch0:		VirtualBox-1.6.2-nodebug.patch
BuildRoot: 	%{_tmppath}/%{name}-buildroot 
#Requires:	kmod-virtualbox
Requires:	xalan-c
Requires:	xerces-c
Requires:	e2fsprogs
BuildRequires:	compat-gcc-34-c++
BuildRequires:  libstdc++-devel
BuildRequires:  dev86
BuildRequires:  iasl
BuildRequires:  zlib-devel
BuildRequires:  libX11-devel
BuildRequires:  libXcursor-devel
BuildRequires:  libXext-devel
BuildRequires:  glibc-devel
BuildRequires:  glib-devel
BuildRequires:  libstdc++-devel
BuildRequires:  SDL-devel
BuildRequires:  qt-devel
BuildRequires:  libIDL-devel
BuildRequires:  e2fsprogs-devel
BuildRequires:  libxslt-devel
BuildRequires:  xerces-c-devel
BuildRequires:  xalan-c-devel >= 1.10
BuildRequires:	libXmu-devel
BuildRequires:	kernel-devel = %{kversion}
BuildRequires:  kernel-PAE-devel = %{kversion}
BuildRequires:	kernel-headers = %{kversion}

# Require for rpm lzma compression transition
Requires:        rpm >= 4.4.2.3-1

%description 
InnoTek VirtualBox is a general-purpose full virtualizer for x86 hardware.
This is the OSE version of VirtualBox.

%package -n	kmod-virtualbox
Summary:        %{name} kernel module.
Release:	%{release}.%{kmodver}
Group:          System/Kernel
Requires:	kernel = %{kversion}
BuildRequires:	kernel-devel = %{kversion}
BuildRequires:	kernel-headers = %{kversion}

%description -n kmod-virtualbox
Kernel module for VirtualBox 

%package -n     kmod-virtualbox-PAE
Summary:        %{name} PAE kernel module.
# fixme : strange behaviour occurs when release macro is used
Release:       	1.%(echo %{kversion} | tr - _)
Group:          System/Kernel
Requires:       kernel-PAE = %{kversion}
BuildRequires:	kernel-PAE-devel = %{kversion}
BuildRequires:	kernel-headers = %{kversion}

%description -n kmod-virtualbox-PAE
VirtualBox kernel module for PAE enabled kernels

%post
ldconfig

%postun
ldconfig

%post -n kmod-virtualbox
/sbin/depmod -aeF /boot/System.map-%{kversion}.%{_target_cpu} %{kversion}.%{_target_cpu} > /dev/null || :

%postun -n kmod-virtualbox
/sbin/depmod -aF /boot/System.map-%{kversion}.%{_target_cpu} %{kversion}.%{_target_cpu} > /dev/null || :

%post -n kmod-virtualbox-PAE
/sbin/depmod -aeF /boot/System.map-%{kversion}.%{_target_cpu}.PAE %{kversion}.%{_target_cpu}.PAE > /dev/null || :

%postun -n kmod-virtualbox-PAE
/sbin/depmod -aF /boot/System.map-%{kversion}.%{_target_cpu}.PAE %{kversion}.%{_target_cpu}.PAE > /dev/null || :


# Notice : please delete BUG() in /usr/include/linux/freezer.h:181
# otherwise VirtualBox won't compile - dirty workaround !!!

%prep 
%setup -n VirtualBox-%{version}
%patch0 -p1

%build
CFLAGS="$CFLAGS \
	-Wdeclaration-after-statement \
	-Werror-implicit-function-declaration"
export LIBPATH_LIB="%{_lib}"
./configure  --with-linux=/usr/src/kernels/%{kversion}.%{_target_cpu}/ --disable-pulse --with-gcc=gcc34 --with-g++=g++34
#./configure  --with-linux=/usr/src/kernels/%{kversion}.%{_target_cpu}/ --disable-pulse
. ./env.sh
kmk %_smp_mflags all

# build kernel module
cd out/linux.x86/release/bin/src
for kvar in %kvariants ; 
do
	make KERN_DIR=/usr/src/kernels/%{kversion}.%{_target_cpu}${kvar:+.${kvar}}/ ;
	if [ $kvar != ""  ]; then
		cp  vboxdrv.ko vboxdrv.ko${kvar:+.${kvar}} 
	else
		cp  vboxdrv.ko vboxdrv.ko.plain 
	fi
done
#make KERN_DIR=/usr/src/kernels/%{kversion}-i686/ 

%install 
rm -rf $RPM_BUILD_ROOT 

# install vbox components
mkdir -p $RPM_BUILD_ROOT%{vboxdir}
(cd out/%{vbox_platform}/release/bin && tar cf - .) | \
(cd $RPM_BUILD_ROOT%{vboxdir} && tar xf -)

# install wrappers
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/vbox
cat > $RPM_BUILD_ROOT%{_sysconfdir}/vbox/vbox.cfg << EOF
# VirtualBox installation directory
INSTALL_DIR="%{vboxdir}"
EOF
install -m755 %{SOURCE1} $RPM_BUILD_ROOT%{vboxdir}/vbox-run.sh
mkdir -p $RPM_BUILD_ROOT%{_bindir}
ln -s %{vboxdir}/vbox-run.sh $RPM_BUILD_ROOT%{_bindir}/VirtualBox
ln -s %{vboxdir}/vbox-run.sh $RPM_BUILD_ROOT%{_bindir}/VBoxManage
ln -s %{vboxdir}/vbox-run.sh $RPM_BUILD_ROOT%{_bindir}/VBoxSDL

#install Guest additions for VirtualBox 
install -D -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{vboxdir}/additions/VBoxGuestAdditions.iso

# install kernel module to a more appropriate place
for kvar in %kvariants ;
do
	mkdir -p $RPM_BUILD_ROOT/lib/modules/%{kversion}.%{_target_cpu}${kvar:+.${kvar}}/extra/virtualbox
	if [ $kvar != ""  ]; then 
		cp  out/linux.x86/release/bin/src/vboxdrv.ko${kvar:+.${kvar}} $RPM_BUILD_ROOT/lib/modules/%{kversion}.%{_target_cpu}${kvar:+.${kvar}}/extra/virtualbox/vboxdrv.ko
	else
		cp  out/linux.x86/release/bin/src/vboxdrv.ko.plain $RPM_BUILD_ROOT/lib/modules/%{kversion}.%{_target_cpu}/extra/virtualbox/vboxdrv.ko	
	fi
done

#remove wrong module
rm -rf $RPM_BUILD_ROOT%_libdir/virtualbox/vboxdrv.ko 

# remove unpackaged files
rm -rf $RPM_BUILD_ROOT%{vboxdir}/{src,sdk,testcase}
rm  -f $RPM_BUILD_ROOT%{vboxdir}/tst*

mkdir -p $RPM_BUILD_ROOT%_sysconfdir/udev/rules.d
install -m755 %{SOURCE2} $RPM_BUILD_ROOT%_sysconfdir/udev/rules.d/

# install icons
mkdir -p $RPM_BUILD_ROOT%_datadir/pixmaps
install -m644 %{SOURCE12} $RPM_BUILD_ROOT%_pixmaps/%{name}.png

# install menu entries
mkdir -p $RPM_BUILD_ROOT%_applications
install -m 0644 %{SOURCE13} $RPM_BUILD_ROOT%_applications

%files 
%defattr(-,root,root)
%_sysconfdir/vbox
%_bindir
%_libdir/virtualbox
%attr(4755,root,root) %_libdir/virtualbox/VirtualBox
%_datadir/applications
%_datadir/pixmaps

%files -n kmod-virtualbox
%defattr(-,root,root)
%_sysconfdir/udev
/lib/modules/%{kversion}.%{_target_cpu}/extra/virtualbox/

%files -n kmod-virtualbox-PAE
%defattr(-,root,root)
%_sysconfdir/udev
/lib/modules/%{kversion}.%{_target_cpu}.PAE/extra/virtualbox/

%clean 
rm -rf $RPM_BUILD_ROOT 

%changelog
* Thu Sep 05 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.0.0-1
- Version update
* Tue Sep 03 2008 Christian Metzen <metzench@ccux-linux.de> 1.6.6-1
- Version update
* Sat Aug 30 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.6.4-4
- kernel 2.6.26-9
* Thu Aug 21 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.6.4-3
- kernel 2.6.26-8
* Thu Aug 07 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.6.4-2
- kernel 2.6.26-7
* Wed Aug 06 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.6.4-1
- version update
- kernel 2.6.26-6
* Fri Jul 25 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.6.2-9
- kernel 2.6.26-5
* Wed Jul 23 2008 Christian Metzen <metzench@ccux-linux.de> 1.6.2-8
- rebuild with correct release number
* Wed Jul 23 2008 Christian Metzen <metzench@ccux-linux.de> 1.6.2-7
- Kernel 2.6.26-4
* Sun Jul 20 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.6.2-6
- kernel 2.6.26-3
* Sat Jul 19 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.6.2-5
- kernel 2.6.26-2
* Wed Jul 16 2008 Christian Wasem <wasem@ccux-linux.de> 1.6.2-4
- fixed BUG# 24, added libXmu-devel as BuildRequires
- added post/postun for PAE package
* Fri Jul 11 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.6.2-3
- kernel 2.6.26-1
* Thu Jul 10 2008 Christian Metzen <metzench@ccux-linux.de> 1.6.2-2
- added qt4 libdir
* Thu Jul 10 2008 Christian Metzen <metzench@ccux-linux.de> 1.6.2-1
- Version update
* Sat Jun 07 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.6.0-5
- kernel 2.6.25-8
* Fri May 16 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.6.0-4
- kernel 2.6.25-7
* Sat May 10 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.6.0-3
- kernel 2.6.25-6
* Wed May 07 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.6.0-2
- kernel 2.6.25-5
* Fri May 02 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.6.0-1
- Version update
- kernel 2.6.25-4
* Mon Apr 21 2008 Christian Metzen <metzench@ccux-linux.de> 1.5.6-6
- added patch for unknown symbol in 2.6.25
* Mon Apr 21 2008 Christian Metzen <metzench@ccux-linux.de> 1.5.6-5
- update to 1.5.6_2
* Mon Apr 21 2008 Christian Metzen <metzench@ccux-linux.de> 1.5.6-4
- kernel 2.6.25-3
* Thu Mar 27 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.5.6-3
- kernel 2.6.24-11
* Sat Mar 15 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.5.6-2
- kernel 2.6.24
* Wed Mar 12 2008 Christian Wasem <wasem@ccux-linux.de> 1.5.6-1
- Version update, added virtualbox.desktop as source
* Thu Feb 14 2008 Christian Metzen <metzench@ccux-linux.de> 1.5.4-5
- updated Guest Additions
* Fri Jan 25 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.5.4-4
- kernel 2.6.24-9
* Thu Jan 17 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.5.4-3
- kernel 2.6.24-8
* Mon Jan 07 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.5.4-2
- kernel 2.6.24-7
* Tue Jan 01 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.5.4-1
- Version update
* Sun Dec 30 2007 Christian Metzen <metzench@ccux-linux.de> 1.5.3-5
- kernel 2.6.24-6, modified kernel module group
* Fri Dec 21 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.5.3-4
- kernel 2.6.24-5
* Thu Dec 13 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.5.3-3
- kernel 2.6.24-4
* Sun Dec 09 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.5.3-2
- kernel 2.6.24-3
* Sat Nov 24 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.5.3-1
- Version update, svn 5826
- kernel 2.6.24-1
* Sat Oct 27 2007 Christian Metzen <metzench@ccux-linux.de> 1.5.2-3
- Kernel 2.6.23-7
* Sat Oct 27 2007 Christian Metzen <metzench@ccux-linux.de> 1.5.2-2
- Kernel 2.6.23-6
* Fri Oct 19 2007 Christian Metzen <metzench@ccux-linux.de> 1.5.2-1
- Version update
* Wed Oct 17 2007 Christian Metzen <metzench@ccux-linux.de> 1.5.0-2
- Kernel 2.6.23-5
* Mon Oct 08 2007 Christian Metzen <metzench@ccux-linux.de> 1.5.0-1
- Version update, included GuestAdditions
* Mon Sep 24 2007 Christian Wasem <wasem@ccux-linux.de> 1.4.0-4
- rebuild against xerces-c and xalan-c
* Thu Jun 14 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.4.0-3
- kernel 2.6.21-5
* Mon Jun 11 2007 Christian Metzen <metzench@ccux-linux.de> 1.4.0-2
- kernel 2.6.21-4
* Wed Jun 06 2007 Christian Metzen <metzench@ccux-linux.de> 1.4.0-1
- Version update
* Thu May 10 2007 Christian Metzen <metzench@ccux-linux.de> 1.3.8-5
- cleaned module build, kernel build against must not be running, fixed post/postun sections
* Thu May 10 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.3.8-4
- kernel 2.6.21-2
* Fri Apr 27 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.3.8-3
- kernel 2.6.21-1
* Sun Apr 08 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.3.8-2
- kernel 2.6.20-7
* Thu Mar 15 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.3.8-1
- Version update
- kernel 2.6.20-5
* Sat Feb 24 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.3.6-1
- Version update
- kernel 2.6.20-4
* Sat Feb 17 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.3.4-1
- Version update, svn 934
- kernel 2.6.20-2
* Mon Feb 05 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.3.2-2
- rebuilt against kernel 2.6.20-1
* Sun Feb 04 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.3.2-1
- Initial Release, svn 585
- kernel module built against kernel 2.6.19-6

